Codeforces #180 div2 C Parity Game

// Codeforces #180 div2 C Parity Game
//
// 这个问题的意思被摄物体没有解释
//
// 这个主题是如此的狠一点(对我来说,),不多说了这
//
// 解决问题的思路:
//
// 第一个假设a字符串和b字符串相等,说直接YES
// 假设b串全是0,直接YES
// 注意到a串有一个性质,1的个数不会超过本身的加1.
// a有个1的上限设为x,b有个1的个数设为y,则假设x < y
// 那么直接NO。
//
// 如今普通情况下。就是模拟啦,找到a的后缀和b的前缀一样的
// 最长的长度设为buf。之后对buf之后的部分进行扫描,假设
// b[i] == '1' ,则在a串的前suf中找一个1,把它添到后面,
// 这样就能够找到了。最后判一下在a中的j下标是否小于suf就能够了
// 
// 注意:假设開始a中1的个数是1的时候那么在第一次找到b[i]是1的
// 时候,不用找1.
//
// 解题:
//
// 这样的字符串的题目,情况相对时有那么一点多,关键是曾经看过前缀和后缀
// 作为状态进行转移的动态规划,所以相对有那么一点感觉。感觉是对了。但
// 经历的时间还是太长了。继续练吧。。。。

#include <algorithm>
#include <bitset>
#include <cassert>
#include <cctype>
#include <cfloat>
#include <climits>
#include <cmath>
#include <complex>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <deque>
#include <functional>
#include <iostream>
#include <list>
#include <map>
#include <numeric>
#include <queue>
#include <set>
#include <stack>
#include <vector>
#define ceil(a,b) (((a)+(b)-1)/(b))
#define endl '\n'
#define gcd __gcd
#define highBit(x) (1ULL<<(63-__builtin_clzll(x)))
#define popCount __builtin_popcountll
typedef long long ll;
using namespace std;
const int MOD = 1000000007;
const long double PI = acos(-1.L);

template<class T> inline T lcm(const T& a, const T& b) { return a/gcd(a, b)*b; }
template<class T> inline T lowBit(const T& x) { return x&-x; }
template<class T> inline T maximize(T& a, const T& b) { return a=a<b?

b:a; } template<class T> inline T minimize(T& a, const T& b) { return a=a<b?

a:b; } const int maxn = 1008; string a; int fa[maxn]; string b; int fb[maxn]; int x,y; int len1,len2; int suf; bool cmp(int u){ for (int i=u;i<u+len2;i++){ if (a[i]!=b[i]) return false; } return true; } void solve(){ string s; suf = -1; int i; for (i=len1-1;i>=0;i--){ s = a.substr(i); if (s==b.substr(0,len1-i)){ suf = i; break; } } //cout << // cout << a << endl; // cout << b << endl; //cout << "suf = " << suf << endl; int flag = 0; //cout << "fb = " << fb[len2-1] << endl; if (suf == -1) suf = len1-1; int x = len1 - suf; int j = 0; int even = 0; //cout << " x " << x << endl; i = x; if (fa[len1]&1){ b[i] == '0'; while(!a[j]&&j<suf) j++; j++; } for (; i < len2; i++) { if (b[i]=='1'){ while(j<suf){ if (s[j]=='1'){ break; } j++; } } } if (j<suf){ puts("YES"); }else { puts("NO"); } } void init(){ memset(fa,0,sizeof(fa)); memset(fb,0,sizeof(fb)); len1 = a.size(); len2 = b.size(); x = 0; y = 0; int i; for (i=0;i<len1;i++){ if (a[i]=='1'){ x++; fa[i] = x; } } for (i=0;i<len2;i++) if (b[i]=='1'){ y++; fb[i] = y; } if (( !(x&1) && x < y) || ((x&1) && x+1 < y)){ puts("NO"); return ; } if (!fb[len2-1]){ puts("YES"); return ; } solve(); } int main() { //freopen("G:\\Code\\1.txt","r",stdin); while(cin >> a >> b){ if (a==b){ puts("YES"); continue; } init(); } return 0; }


版权声明:本文博主原创文章,博客,未经同意不得转载。

posted @ 2015-09-22 10:43  mengfanrong  阅读(176)  评论(0编辑  收藏  举报